////////    Vector2D.C    //////////
#include  <iostream>
#include  "Vector2D.h"

float Vector2D::inner(Vector2D& v)
{  return(x * v.x + y * v.y);   }

void Vector2D::display()
{   std::cout << "(" << x << ",  "
              << y << ")";
}

Vector2D Vector2D::difference(Vector2D& v)
{    Vector2D tmp;
     tmp.x = x - v.x;
     tmp.y = y - v.y;
     return tmp;
}

inline float ABS(float x)
       {  return (x > 0 ? x : -x); }

// test if the host is perpendicular to a

bool Vector2D::isPerpendicular(Vector2D& v)
{   return ( nonzero() && v.nonzero()
             && ABS(inner(v)) < 0.00000001 );    // delta = 0.00000001
}

// test if the host is parallel to a (pointing in the same direction)

bool Vector2D::isParallel(Vector2D& v)
{   return( nonzero() && v.nonzero() &&
            x*v.x >= 0.0 &&
            y*v.y >= 0.0 &&
            ABS(x*v.y-y*v.x) < 0.00000001
          );
}
