///////    Cirbuf.C    ///////
#include        <iostream>
#include        "Cirbuf.h"
using std::cout; using std::cerr;      // namespace declarations
using std::endl;

Cirbuf::Cirbuf(int s /* = D_SIZE */)   // constructor
{    head = tail = length = 0;         // initial values
     size = s;
     cb = new char[s];                 // allocate buffer space
}

Cirbuf::~Cirbuf()
{    delete [] cb;                     // free up space
}

int Cirbuf::produce(char c)           // insert c into buffer
{    if ( isFull() )                  // if buffer full
     {  cerr << "produce: buffer full"
             << endl;
        return -1;                    // return error value
     }
     cb[tail] = c;
     length++;
     incr(tail);                      // increment with wrap-around
     return 0;                        // normal return value
}

int Cirbuf::consume()                 // extract char from buffer
{    char c;
     if ( isEmpty() )
     {  cerr << "consume: buffer empty"
             << endl;
        return -1;
     }
     c = cb[head];
     length--;
     incr(head);                      // increment with wrap-around
     return c;                        // return character
}
