#ifndef __Matrix_SEEN__
#define  __Matrix_SEEN__
///////    Matrix.h    ///////
#include <iostream>

class Matrix
{ public:
    Matrix() { mat = NULL; }
    Matrix(int r, int c);
    Matrix(double* m, int r, int c);
    ~Matrix() { delete mat; }
    double getElement(int i, int j) const;
    void setElement(int i, int j, double e);
    int rows() const { return nr; }
    int cols() const { return nc; }
    void times(const Matrix& b, Matrix& ans) const;
    void display() const;
  private:
    void setUp(int r, int c);
    double rowTimesCol(int i, double* b, int j, int bc) const;
    double* mat;           // the matrix
    int nr, nc;            // rows and cols
};
#endif
