///////    TextLines.C    ///////
#include <iostream>
#include "TextLines.h"

using std::getline;
using std::cin; using std::cout;
using std::cerr; using std::endl;
using std::ios;

bool TextLines::insert
(const string& l, int i)
{  if ( 0 <= i && i < line.size() )
       line.insert(line.begin()+i, new string(l));
   else if ( i == line.size() )
       line.push_back(new string(l));
   else return false;
   return true;
}

void TextLines::input(istream& in)
{   int l = readLines(in);
    if (l > 0 ) return;
    if (l == -1)
        cerr << "TextLines: Failed to read input file" 
             << endl;
    if ( l == 0 )
        cerr << "TextLines: Input file empty" << endl;
    in.setstate(ios::badbit);  // input failed
}

int TextLines::readLines(istream& in)
{   int error = 0;
    int count = 0;
    string* tl = new string();
    while( getline(in, *tl, '\n') )
    {  if ( in.fail() )  // input failed
       {   error = -1; break; }
       line.push_back(tl);
       count++;
       tl = new string();
    }
    return(error ? error : count);  // error or lines read 
}

void TextLines::display(ostream& out) const
{   for ( int i = 0; i < line.size(); i++ )
         out << *line[i] << endl;
}

TextLines::~TextLines()
{   int len = line.size();
    while(len-- > 0)
       delete line[len];
}
