#ifndef TextLines_SEEN__
#define TextLines_SEEN__
///////    TextLines.h    ///////
#include <iostream>
#include <vector>
#include <string>
using std::string; using std::istream;
using std::vector;

class TextLines
{ public:
    TextLines(int cap=512) 
    {  line.reserve(cap);  }            // (1)
    int length() { return line.size(); }
    void swap(int i, int j);            // interchanges lines
    void input(istream& in);            // reads lines into host
    void remove(int i);                 // removes line i
    ~TextLines();                       // destructor
    string* operator[](int i) const     // gets line i
    {  return (i >= 0 && i < line.size())
              ? line[i] : NULL;
    }
    void display(ostream& out) const; 
    bool insert(const string& l, int i); // insert before line i
  private:
    int readLines(istream& in);  // performs line reading
    vector<string*> line;  // vector of string* 
};

inline void TextLines::swap(int i, int j)
{   string* tmp = line[i];
    line[i] = line[j];
    line[j] = tmp;
}

inline void TextLines::remove(int i)
{   delete line[i];
    line.erase(line.begin()+i);
}
#endif
