///////    mysortArb.C    ///////

//// mysort reprogramed using arbsort instead of
////   hard coded quicksort
#include <iostream>
#include "TextLines.h"
#include "SortKey.h"
#include "../arbsort/arbqsort.h"
using namespace std;

//  To compile:
//  g++ mysortArb.C ../arbsort/arbqsort.C SortKey.C TextLines.C

int keycmp(TextLines *tl, int i, int j)
{    SortKey sk;
     TextLines& txtobj= *tl;
     return( sk.lineCompare(*txtobj[i], *txtobj[j]) );
}

void lineswap(TextLines *tl, int i, int j)
{    tl->swap(i,j);    }


SortKey sk;   // default global sort key

int main(int argc, char* argv[])
{    if (argc > 2)
     {   cerr << "Usage: " << argv[0] 
                   << " key_position" << endl;
         return 1;
     }
     if (argc == 2) sk = SortKey(atoi(argv[1]));
     TextLines txtobj;
     txtobj.input(cin);
     if ( cin.bad() ) 
     {   cerr << "failed reading input." << endl;
         return 1;
     }
     quicksort(&txtobj, 0, txtobj.length()-1,
               reinterpret_cast< CMP_FN >(keycmp), 
               reinterpret_cast< SWAP_FN >(lineswap));
     txtobj.display(cout);
     return 0;
}
