///////    List.C    ///////
#include <iostream>
#include "List.h"
using std::cout;

// slave class for List
class ListCell
{   friend class List;
  private:                             // all members private
    char item;                         // item is a character
    ListCell* next;
    ListCell(char a = '\0',            // constructor
             ListCell* ptr = NULL)
    :  item(a), next(ptr) { }          // constructor init-list
};

List::List(char c)         // list with first cell
: head (new ListCell(c,NULL)) { }

List::~List() {   free();  }

char List::content(ListCell* p)
{ return p->item; }

void List::free() // private method
{    ListCell* n, *p = head;
     while (p)
     {   n = p->next;
         delete p;
         p=n;
     }
}

int List::shorten(int n)
{    while (n-- && head)
     {   ListCell* tmp=head;
         head = head->next;
         delete(tmp);
     }
     return - ++n;
}

int List::remove(char c)
{     ListCell *tmp, *p = head;
      int count = 0;
      if ( p == NULL ) return count;
      while (p->next)      // treat all but head cell
      {  if ((p->next)->item == c)
         {   count++;
             tmp = p->next;
             p->next = tmp->next;
             delete(tmp); // free up store
         }
         else
                p = p->next;
      }
      if( head->item == c ) // treat head cell
      {  tmp = head;
         head = head->next;
         delete(tmp);
         count++;
      }
      return count;        // number of items removed
}

bool List::putOn(char c)
{     ListCell* tmp = new ListCell(c,head);
      if ( tmp )
      {  head = tmp;
         return true;
      }
      else return false; // failed
}

// insert after entry e
// if e is NULL insert at head
bool List::insert(char c, ListCell* e)
{     if ( e == NULL ) return putOn(c);
      ListCell* tmp = new ListCell(c,e->next);
      if ( tmp )
      {  e->next = tmp;
         return true;
      }
      else return false; // failed
}

ListCell* List::last()
{     ListCell* p = head;
      while( p && p->next ) p =  p->next; 
      return p;
}

ListCell* List::find(char c)
{   for( ListCell* p = head; p ; p = p->next )
       if( p->item == c )
           return p;
    return NULL;  // c not on list
}

bool List::substitute(char r, char s)
{     ListCell* p = find(s);
      if( p == NULL ) return false;     // s not on list
      p->item = r;
      return true;
}

// display from p to end
void List::display(ListCell* p) const
{   cout << "(";
    while ( p )
    {    cout << p->item;
         if ( p = p->next ) cout << " ";
    }
    cout << ")";
}
