#ifndef List_SEEN__
#define List_SEEN__
///////     List.h    ///////

class ListCell;  // defined in List.h

class List
{ public:
    List() : head(NULL) { }            // constructor, empty list
    List(char c);                      // constructor, list with one cell
    ListCell* first() { return head; } // first cell
    ListCell* last();                  // last cell
    ListCell* find(char c);            // first item == c
    char content(ListCell* p);         // get content
    bool substitute(char r, char s);   // substitute r for first s
    int remove(char c);                // remove c from entire list
    void remove(ListCell* cell);       // remove given cell
    int shorten(int n);                // remove first n cells
    bool putOn(char c);                // insert c in front
    bool insert(char c, ListCell* c);  // insert c after cell
    int append(char c)                 // insert c at end
    { return insert(c, last()); }
    void display(ListCell* p) const;   // display from p to end
    void display() const               // display whole list 
    { display(head); }  
    bool isEmpty() const { return head == NULL; }
    ~List();                           // destructor
  private:
    ListCell* head;                    // first cell of list
    void free();                       // free all cells
};
#endif
