////////  Vector2D.C  //////////
#include  <iostream>
#include  "Vector2D.h"

Vector2D::Vector2D(float a, float b)
{   x = a;  
    y = b;
}

float Vector2D::inner(Vector2D a)
{  return(x * a.x + y * a.y);   }

Vector2D Vector2D::operator-(Vector2D a)
{    Vector2D tmp;
     tmp.x = x - a.x;
     tmp.y = y - a.y;
     return tmp;
}

inline float ABS(float x)
       {  return (x > 0 ? x : -x); }

// test if the host is parallel to a (pointing in the same direction)

int Vector2D::isParallel(Vector2D a)
{   return( nonzero() && a.nonzero() &&
            x*a.x >= 0.0 &&
            y*a.y >= 0.0 &&
            ABS(x*a.y-y*a.x) < 0.00000001
          );
}



void Vector2D::display(ostream& out /*= cout*/) const
{  out << "(" << x << ", " << y << ")"; }

ostream& operator <<(ostream& out, const Vector2D& v)
{   v.display(out);
    return out;
}

void Vector2D::read(istream& in /* = cin */)
{   char c1, c2, c3;
    float x1, y1;
    in >> c1 >> x1 >> c2 >> y1 >> c3;
    if ( c1 != '(' || c2 != ',' || c3 != ')' )
         // clear() sets error state
         in.clear( ios::badbit | in.rdstate() );
    else
    {    x = x1; y = y1;  }
}

istream& operator >>(istream& in, Vector2D& v)
{    v.read(in);
     return in;
}
