///////    FreeChecking.C    ///////
#include <iostream>
#include "FreeChecking.h"
using std::cerr; using std::endl;

float FreeChecking::min_bal = 500.0;
float FreeChecking::service_fee = 18.0;

FreeChecking::FreeChecking             // constructor
(unsigned n, double b, const string& owner)
:   Account(n, b, owner),
    free(b >= min_bal)                 // init-list
{ }

bool FreeChecking::withdraw(double amt)
{   bool ok = Account::withdraw(amt);        
    if ( ok && balance() < min_bal )
         free = false;
    return ok;
}

void FreeChecking::fee()
{  if ( ! free )
      if ( Account::withdraw(service_fee) )
         free = (balance() >= min_bal);   // reset free flag
      else
         cerr << "fee: Insufficient balance for account " 
              << acct_no << endl;
}
