///////    Cirbuf.C  with Assignment and Copy    ///////
#include  <iostream>
#include  "Cirbuf.h"

Cirbuf::Cirbuf(int s /* = D_SIZE */)   // constructor
{    head = tail = length = 0;         // initial values
     size = s;
     cb = new char[s];                 // allocate buffer space
}

Cirbuf::~Cirbuf()
{    delete [] cb;                     // free up space
}

int Cirbuf::produce(char c)           // insert c into buffer
{    if ( isFull() )                  // if buffer full
     {  std::cerr << "produce: buffer full"
                  << std::endl;
        return -1;                    // return error value
     }
     cb[tail] = c;
     length++;
     incr(tail);                      // increment with wrap-around
     return 0;                        // normal return value
}

int Cirbuf::consume()                 // extract char from buffer
{    char c;
     if ( isEmpty() )
     {  std::cerr << "consume: buffer empty"
                  << std::endl;
        return -1;
     }
     c = cb[head];
     length--;
     incr(head);                      // increment with wrap-around
     return c;                        // return character
}

Cirbuf& Cirbuf::operator= (const Cirbuf& b)
{   if (&b == this) return(*this);
    head = 0;
    tail = length = b.length;
    if ( size != b.size )
    {   delete [] cb;
        size = b.size;
        cb = new char[size];
    }
    for (int i=0 ; i < length ; i++)
        cb[i] = b.cb[(b.head + i) % size];
    return *this;
}

Cirbuf::Cirbuf(const Cirbuf& b)
{   head = 0;
    tail = length = b.length;
    size = b.size;
    cb = new char[size];
    for (int i=0 ; i < length ; i++)
        cb[i] = b.cb[(b.head + i) % size];
}
