#ifndef __Cirbuf_SEEN__
#define  __Cirbuf_SEEN__
///////    Cirbuf.h  with Assignment and Copy    ///////
#include <iostream>

class Cirbuf   // circular buffer
{ public:
    enum { D_SIZE = 16 };        // default buffer size
    Cirbuf(int size = D_SIZE);   // constructor
    int produce(char c);         // insert c into buffer
    int consume();               // remove char from buffer
    bool isEmpty()               // buffer empty test
    { return(length == 0); }
    bool isFull()
    { return(length == size); }  // buffer full test
    Cirbuf& operator= (const Cirbuf& b); // assignment
    Cirbuf(const Cirbuf& b);             // copy constructor
    ~Cirbuf();                           // destructor
  private:
    int head;          // first char in buffer
    int tail;          // first empty slot in buffer
    int length;        // number of characters in buffer
    int size;          // capacity of buffer
    char *cb;          // pointer to buffer
    void incr(int& x)  // index wrap-around
    { if (++x == size ) x = 0; }
};
#endif
