///////    gcdone.C    ///////
#include <iostream>
#include <stdlib.h>
using std::cerr; using std::endl;
using std::cout;

class WrongArg       // an exception class
{   public:
      explicit WrongArg(const char* msg)
      : err(msg) { }
      const char* errorMsg() const
      {  return err;  }
    private:
      const char* err;
};

inline long int ABS(long int x) { return(x < 0 ? -x : x); } 

unsigned int gcd(long int a, long int b)
         throw(WrongArg)
{   if ( a==0 && b==0 )
        throw(WrongArg("gcd(0,0) undefined"));
     int t;
     a = ABS(a);
     b = ABS(b);
     if ( a == 0 ) return b;    // 0 is error value
     if ( b == 0 ) return a;
     while ( b > 0 )
     {   t = a % b;
         a = b;
         b = t;
     }
     return a;
}

inline void THROW() 
       { throw(WrongArg("needs 2 integer arguments")); }

void get_ab(int argc, char* argv[], 
            long int& a, long int& b)
     throw(WrongArg)
{   if ( argc != 3 ) THROW();
    char* end[1];
    a = strtol(argv[1], end, 10);
    if ( end[0] != argv[1]+strlen(argv[1]) )
         THROW();
    b = strtol(argv[2], end, 10);
    if ( end[0] != argv[2]+strlen(argv[2]) )
         THROW();
}

int main(int argc, char* argv[])
{     try                                  // try block
      {    long int a,b;
           get_ab(argc, argv, a, b);
           long int d = gcd(a,b);
           cout << "gcd(" << a << "," << b << ")="
                << d << endl;
      }
      catch ( WrongArg& a )                // error catch (1)
      {    cerr << argv[0] << ": " 
                << a.errorMsg() << endl;   // handling    (2)
           return 1;                       //    codes    (3)
      }
      catch (...) 
      {  }
      return 0;
}

