#ifndef __Matrix_SEEN__
#define  __Matrix_SEEN__
///////    Matrix.h    ///////
#include "MatrixException.h"

class Matrix
{ public:
    Matrix(int r, int c);
    Matrix(double* m, int r, int c);
    ~Matrix() { delete mat; }
    double getElement(int i, int j) const
         throw(InvalidIndex);
    void setElement(int i, int j, double e)
         throw(InvalidIndex);
    int rows() const { return nr; }
    int cols() const { return nc; }
    Matrix& times(const Matrix& b) const
         throw(IncompatibleDimension);
    void display() const;

  private:
    void setUp(int r, int c);
    double rowTimesCol(int i, double* b, int j, int bc) const;
    double* mat;           // the matrix
    int nr, nc;            // rows and cols
};
#endif
