#ifndef __MatrixException_SEEN__
#define  __MatrixException_SEEN__
///////    MatrixException.h    ///////
#include <stdexcept>

class MatrixException : public logic_error
{ public:  
    explicit MatrixException(const string& s)
    : logic_error(s) {  }
};

class Singular: public MatrixException
{ public:
    explicit Singular(const string& s)
    : MatrixException("Singular: "+s) {  }
};

class InvalidIndex: public MatrixException
{ public:
    explicit InvalidIndex(const string& s)
    : MatrixException("Invalid index: "+s) {  }
};

class IncompatibleDimension: public MatrixException
{ public:
    explicit IncompatibleDimension(const string& s)
    : MatrixException("Incompatible Dimensions: "+s) {  }
};

#endif
