///////    TextLines.C    ///////
#include <iostream>
#include <string>
#include <stdlib.h>
#include "TextLines.h"
using std::getline; using std::cin; using std::cout;
using std::cerr; using std::endl; using std::ios;

void TextLines::input(istream& in)
{   int l = readLines(in);
    if (l > 0 ) { len = l; return; }
    if (len == -1)
        cerr << "TextLines: Failed to read input file" 
             << endl;
    if ( l == 0 )
        cerr << "TextLines: Input file empty" << endl;
    in.setstate(ios::badbit);  // input failed
}

int TextLines::readLines(istream& in)
{   int error = 0;
    int count = 0;
    string* tl = new string();
    while( getline(in, *tl, '\n') )
    {  if ( in.fail() )  // input failed
       {   error = -1; break; }
       line.insert(line.end(), tl);
       count++;
       tl = new string();
    }
    return(error ? error : count);  // error or lines read 
}

void TextLines::display()
{   for ( int i = 0; i < len; i++ )
         cout << *line[i] << endl;
}

TextLines::~TextLines()
{    while(len-- > 0)
       delete line[len];
}
