///////    mysort.C    ///////
#include <iostream>
#include "TextLines.h"
#include "SortKey.h"

int partition(TextLines& txtobj, int l, int r,
              const SortKey& sk)
{   register int i=l, j=r;
    string piv;
// choose middle element as pivot
//  use indexing for swapping
    string* foo = txtobj[(i+j)/2];
    txtobj[(i+j)/2] = txtobj[j];
    txtobj[j]  = foo;
    piv = *txtobj[j];       // overloaded []
    while (i < j)
    {    while (sk.lineCompare(*txtobj[i], piv) <= 0 && i < j) i++;
         while(j > i && sk.lineCompare(*txtobj[j], piv) >= 0) j--;
         if (i < j) txtobj.swap(i++,j);
    }
    if (i != r) txtobj.swap(i,r);
    return i;
}

void quicksort(TextLines& txtobj, int l, int r, 
     const SortKey& sk)
{   int k;
    if ( l >= r || l < 0 || r < 0)  return;
    k = partition (txtobj, l, r, sk);
    quicksort(txtobj, l, k-1, sk);
    quicksort(txtobj, k+1, r, sk);
}

int main(int argc, char* argv[])
{    if (argc > 2)
     {   cerr << "Usage: " << argv[0] 
                   << " key_position" << endl;
         return 1;
     }
     SortKey sk;
     if (argc == 2) sk = SortKey(atoi(argv[1]));
     TextLines txtobj;
     txtobj.input(cin);
     if ( cin.bad() ) 
     {   cerr << "failed reading input." << endl;
         return 1;
     }
     quicksort(txtobj,0,txtobj.length()-1, sk);
     txtobj.display();
     return 0;
}
