#ifndef __Cirbuf_SEEN__
#define  __Cirbuf_SEEN__
///////    Cirbuf.h    ///////

class Cirbuf   // circular buffer
{ public:
    class iterator;
    typedef const iterator const_iterator;

    enum { D_SIZE = 16 };        // default buffer size
    Cirbuf(int size = D_SIZE);   // constructor
    int produce(char c);         // insert c into buffer
    int consume();               // remove char from buffer
    bool isEmpty()               // buffer empty test
    { return(length == 0); }
    bool isFull()
    { return(length == size); }  // buffer full test
    ~Cirbuf();                   // destructor

    class iterator
    {  friend class Cirbuf;
       public:
          const_iterator& operator++() const
          {   ++(const_cast< int& >(position));
              return *this;
          }
          iterator& operator++()
          {   ++position;
              return *this;
          }
          bool operator !=(const iterator& b) const
          {   return position != b.position;  }

          char operator *() const
          {   return 
	          buf.cb[(buf.head+position)
	                  % buf.size];
          }

          char& operator *()
          {   return 
	          buf.cb[(buf.head+position)
	                  % buf.size];
          }
       private:
          iterator(Cirbuf& b, int i)
          :  buf(b), position(i) { }
          Cirbuf& buf;
          int position;
    };

  friend class Cirbuf::iterator;

    iterator begin(){ return iterator(*this, 0); }
    const_iterator begin() const 
    { return iterator(const_cast< Cirbuf& >(*this), 0); }
    const_iterator end() const 
    { return iterator(const_cast< Cirbuf& >(*this), length); }
  private:
    int head;          // first char in buffer
    int tail;          // first empty slot in buffer
    int length;        // number of characters in buffer
    int size;          // capacity of buffer
    char *cb;          // pointer to buffer
    void incr(int& x)  // index wrap-around
    { if (++x == size ) x = 0; }
};
#endif
