#ifndef __Account_SEEN__
#define  __Account_SEEN__
///////    Account.h    ///////
#include <iostream>
using std::cout; using std::endl;

class Account 
{ public:
     Account() {}                    // default constructor
     Account(unsigned n, double b,   // constructor
             char* ss); 
     virtual void deposit(double amt);    // deposit amt into this account
     virtual bool withdraw(double amt);   // withdraw amt from this account
     virtual unsigned id() const          // get account number
     {  return acct_no;  }
     virtual double balance() const;      // balance inquiry
     virtual void display(ostream&        // display account info
                  out = cout) const;
     /* other public members */
     virtual ~Account()                   // virtual destructor
     { cout << "Account Destructor" << endl; }
  protected:
     enum {SS_LEN = 12};
     unsigned  acct_no;              // account number
     char      ss[SS_LEN];           // owner ss no.
  private:
     /* other members */
     double    acct_bal;             // current balance
};
#endif

