///////    FreeChecking.C    ///////
#include "FreeChecking.h"

float FreeChecking::min_bal = 500.0;
float FreeChecking::service_fee = 18.0;

FreeChecking::FreeChecking
(unsigned n, double b, char* owner)
: Account(n, b, owner), free(1)
{   if ( balance() < min_bal )
        free = 0;
}

bool FreeChecking::withdraw(double amt)
{   int ok = Account::withdraw(amt);
    if ( ok )
        if ( free && balance() < min_bal )
            free = 0;
    return ok;
}

void FreeChecking::fee()
{   if ( ! free )
        withdraw(service_fee);
}

void FreeChecking::display(ostream& out /* = cout */) const
{   out << "Free Checking Account" << endl;
    Account::display();
}
