///////     ArbTree.C    ///////
//  Generic Tree
#include <iostream>
#include "ArbTree.h"

// used by destructor
void ArbTree::free(TreeNode* nd)
{   if ( nd == NULL ) return;
    if ( nd->isLeaf() ) delete nd;
    else 
    {   ChildCell* t= (dynamic_cast<InNode*>(nd))->children;
        ChildCell* tmp; 
        while ( t != NULL )
        {   tmp = t->next;
            free(t->child);
            delete t;
            t = tmp;
        }
        delete nd;
    }
}

int ArbTree::size(TreeNode* n)
{   if ( n == NULL ) return 0;
    if ( n->isLeaf() ) return 1;
    int count=0;
    ChildCell* c = (dynamic_cast<InNode*>(n))->children;
    while ( c != NULL )
    {   count += size(c->child);
        c = c->next;
    }
    return count+1;
}

ArbTree::Iterator&
ArbTree::Iterator::operator++()   // next node
{  switch(mode)
   {// case POSTORDER: current=postNext(); break;
    // case INORDER: current=inNext();     break;
       default: current=preNext();         break;
   }
   return *this;
}

// returns next node in preorder
TreeNode* ArbTree::Iterator::preNext()
{  if ( current == NULL ) return NULL;  // iteration ended
   if ( ! current->isLeaf() )           // internal node
   {  InNode* n = dynamic_cast<InNode*>(current);
      if ( n->nextChild(NULL) != NULL ) 
          return (n->nextChild(NULL));  // first child node
   }
   TreeNode *d=current, *nd;
   InNode* p;
   while ( d != NULL )
   {   p = d->getParent();
       if ( p == NULL ) break;
       else nd = p->nextChild(d);
       if ( nd != NULL )  return nd;
       else d = d->getParent();
   }
   return NULL;    // no more next node
}
