///////     TreeNode.C    ///////
#include <iostream>
#include "TreeNode.h"

//  an internal node
InNode::InNode(any it) 
:   TreeNode(it)
{  children = NULL;
   childCount = 0;
}

// returns child next to c 
//   or first child if c is NULL
TreeNode* InNode::nextChild(TreeNode* c)
{   if ( c == NULL  && childCount > 0 )
         return children->child;
    ChildCell *t1 = children, *t;
    for (t1 = children ; t1 != NULL ; t1=t1->next)
    {   if ( t1->child == c && t1->next != NULL )
           return t1->next->child;
    }
    return NULL;   // no child next to c
}

// adding another child to the intenal node
// order of adding is significant
void InNode::addChild(TreeNode* n)
{   if ( n == NULL ) return;
    ChildCell* t;
    n->setParent(this);
    ChildCell* c = new ChildCell(n);
    if ( children == NULL ) 
         children = c;
    else
    {   for ( t=children; t != NULL && t->next != NULL;
              t=t->next ) {}
        t->next = c;
    }
    childCount++;
}

TreeNode* InNode::getChild(int i)  // 0-based indexing
{   ChildCell* t = getCell(i);
    if ( t == NULL ) return NULL;
    return t->child;
}

ChildCell* InNode::getCell(int i)  // 0-based indexing
{   ChildCell *t = children;
    if ( i >= 0 && i < childCount )
    {   while ( --i > -1 ) t = t->next; 
        return t;
    }
    return NULL;
}

bool InNode::replaceChild(int i, TreeNode* d)
{   ChildCell *t = getCell(i);
    if ( t == NULL ) return false;
    t->child = d;
    return true;
}

bool InNode::deleteChild(int i)
{   ChildCell *t1 = children, *t;
    if ( i >= 0 && i < childCount )
    {   if ( i == 0 )
        {   children = children->next;
            delete t;
        }
        else
        {   t = getCell(i-1);
            t1 = t->next;
            t->next = (t1->next);
            delete t1;
        }
        childCount--;
        return true;
    }
    return false;
}
