///////    testArbTree.C    ///////
#include <iostream>
#include "ArbTree.h"
using std::cout; using std::endl;

void valueDisplay(TreeNode* n)
{    void* s = n->getValue();
     cout << *(reinterpret_cast< char** >(s));
}

void prefixDisplay(TreeNode* n)
{   if ( n->isLeaf() )
    {    valueDisplay(n);
         return;
    }
    else
    {   InNode* op = dynamic_cast< InNode* >(n);
        cout << "("; 
        valueDisplay(op);
        for ( int i=0; i < op->getChildCount(); i++ )
        {  cout<< " ";
           prefixDisplay(op->getChild(i));
        }
        cout << ")";
    }
}

int main(int argc, char* argv[])
{    char* a[10] = {"*","+","-","/","a","b","c","d","e","f"};
     InNode* in[4];
     for (int i=0, j=4; i<4; i++)
     {   in[i] = ArbTree::parent(a+i);
         if ( i > 0 )
         {   in[0]->addChild(in[i]);
             in[i]->addChild(ArbTree::leaf(a+j++));
             in[i]->addChild(ArbTree::leaf(a+j++));
         }
     }
     ArbTree* t = new ArbTree(in[0]);
     cout << "Tree has " << t->size() 
              << " nodes." << endl;
     ArbTree::Iterator s = t->begin(ArbTree::PREORDER);
     ArbTree::Iterator e = t->end(ArbTree::PREORDER);
     // Preorder traversal
     while ( s != e )
     {    valueDisplay(&(*s));
          ++s;
          if ( s != e )  cout << ", ";
          else cout << endl;
     }
     TreeNode& n = *(t->begin(ArbTree::PREORDER));
     prefixDisplay(&n);
     cout << endl;
     delete t;
     return 0;
}


/**** output is

*, +, a, b, -, c, d, /, e, f
(* (+ a b) (- c d) (/ e f))

****/
