#ifndef __Fraction_SEEN__
#define  __Fraction_SEEN__
///////    Fraction.h    ///////
// With friend operators and I/O operators
#include <iostream>
#include "IOable.h"

class Fraction : public IOable
{       friend Fraction operator +(const Fraction&,int);
   public:
     Fraction() { }
     Fraction(int n, int d);                         // d is not zero
     void read(istream& in = cin);                   // input fraction
     void display(ostream& out = cout) const;        // display fraction
     Fraction operator + (const Fraction& y) const ;
     Fraction operator - () const ;                  // unary negation
     Fraction operator - (const Fraction& y) const ;
     Fraction operator * (const Fraction& y) const ;
     Fraction operator / (const Fraction& y) const ;
     bool operator == (const Fraction& y) const ; 
     bool operator >  (const Fraction& y) const ;
     bool operator <  (const Fraction& y) const ;
     bool operator >= (const Fraction& y) const ;
     bool operator <= (const Fraction& y) const ;
     bool isZero() const ;
     bool isOne() const ;
     bool isInt() const ;
     int getNumerator() { return num; }
     int getDenominator() { return denom; }
     int floor() const ;
     int ceiling() const ;
   private:
     static Fraction makeFraction(int n, unsigned d)
     {   Fraction ans;
         ans.num = n; ans.denom = d;
         return ans;
     }
     int num;
     int denom;
};

inline Fraction operator *(const Fraction& fra, int i)
       {   
           return(fra*Fraction(i,1));
       }

inline  void Fraction::display(ostream& out /*= cout*/) const
        {  out << num << "/" << denom; }

inline  bool Fraction:: operator ==(const Fraction& y) const
        {  return( num == y.num && denom == y.denom );
        }

inline  bool Fraction::isZero() const
        { return ( denom == 1 && num == 0 ); }

inline  bool Fraction::isOne() const  
        { return ( denom == 1 && num == 1 ); }

inline  bool Fraction::isInt() const  
        { return ( denom == 1 ); }
#endif
