#ifndef DateSeq_SEEN__
#define DateSeq_SEEN__
///////    DateSeq.h    ///////
#include <iostream>
#include <vector>
#include <stdexcept>
#include "Date.h"
#include "OrderedSeq.h"
using std::out_of_range;   // exception


class DateSeq : public OrderedSeq
{ public:
    const Date& operator[](unsigned i)
        throw(out_of_range); 
    bool enter(Date& d)                    // add d, false if failed 
    {  return OrderedSeq::enter(&d);  }
    int index(Date& d)                     // -1 if not found
    {  return OrderedSeq::index(&d);  }
    void remove(unsigned i)                // remove by index
        throw(out_of_range); 
  protected:
    bool  append(void* date);              // add any at end,
  private:
    void swap(unsigned i, unsigned j);     // interchange elements
    int cmp(unsigned i, unsigned j) const; // compare elements
    int cmp(void* date, unsigned j) const; // compare key to element
    vector<Date*> dates;
};

inline void DateSeq::swap(unsigned i, unsigned j)
       {  Date* tmp = dates[i];
          dates[i]  = dates[j];
          dates[j]  = tmp;
       }

inline int DateSeq::cmp(unsigned i, unsigned j) const
       {  return dates[i]->cmp(*dates[j]); }

inline int DateSeq::cmp(void* date, unsigned j) const
       {  Date* tmp = (Date*) date;
          return tmp->cmp(*dates[j]);
       }
#endif
