#ifndef OrderedSeq_SEEN__
#define OrderedSeq_SEEN__
///////    OrderedSeq.h    ///////
#include <stdexcept>
using std::out_of_range;


class OrderedSeq  // abstract base class
{ public:
    OrderedSeq() : ordered(true), len(0) {}  // default constructor
    unsigned length() const { return len; }  // current length of seq
    virtual void remove(unsigned i)          // remove by index     
          throw(out_of_range)           =0; 
    virtual ~OrderedSeq() {}                 // virtual destructor
  protected:
    virtual bool enter(void* any);           // false if failed
    virtual int  index(void* key);           // -1 if not found
    virtual bool append(void* any)      =0;  // at end, false if failed
    virtual void sort();                     // sort into order
    virtual bool sorted() const              // false if seq not sorted
    { return ordered;}
    virtual void sorted(bool s) 
    { ordered = s;}                          // set sorted flag
    unsigned len;                            // sequence length
  private:
    virtual void swap(unsigned i, unsigned j) =0;      // interchange items
    virtual int cmp(unsigned i, unsigned j) const =0;  // compare items
    virtual int cmp(void* key, unsigned j) const =0;   // compare key to item
    void quicksort(int l, int r);
    unsigned partition(unsigned l, unsigned r);
    bool ordered;                                       // sorted flag
};
#endif
