#ifndef TextLineSeq_SEEN__
#define TextLineSeq_SEEN__
///////    TextLineSeq.h    ///////
#include <iostream>
#include <stdexcept>
#include "../../ex04/sortline/TextLines.h"
#include "../../ex04/sortline/SortKey.h"
#include "OrderedSeq.h"
using std::out_of_range;   // exception

class TextLineSeq : public OrderedSeq 
{ public:
    TextLineSeq(SortKey& k) : key(k) {}
    const string& operator[](unsigned i)   // returns line i >= 0
         throw(out_of_range);              //   may sort first
    bool enter(string& l)                  // adds line, false if failed 
    { return OrderedSeq::enter(&l); }      // (1)
    int index(string& key)                 // finds line by key, -1 not found
    { return OrderedSeq::index(&key); }
    void input(istream& in);               // reads line into sequence
    void remove(unsigned i)                // deletes line i >= 0
    {  txtobj.remove(i); len--; }
    void output(ostream& out=cout);        // may sort first
  protected:
     bool append(void* line);              // appends line at end
  private:
     int cmp(unsigned i, unsigned j) const;
     int cmp(void* k, unsigned j) const;
     void swap(unsigned i, unsigned j)     // interchanges lines
     {  txtobj.swap(i,j);  }
     SortKey& key;                         // sort key manager
     TextLines txtobj;
};

inline int TextLineSeq::cmp
(unsigned i, unsigned j) const
{  return key.lineCompare(*txtobj[i],
                          *txtobj[j]);
}

inline int TextLineSeq::cmp
(void* k, unsigned j) const
{ return  key.keyCompare(
     *(reinterpret_cast<string*>(k)),
     *txtobj[j]);
}

inline void TextLineSeq::output(ostream& out)
{   if ( ! sorted() ) sort();
    txtobj.display(out);
}
#endif
