#ifndef VectorND_SEEN__
#define VectorND_SEEN__
#pragma interface
///////    VectorND.h    ///////
// n dimensional vector of type T elements

template <typename T, int n>                // template parameters
class VectorND
{   friend VectorND<T,n> operator*<T,n>     // friend syntax  
           (int m, const VectorND<T,n>& v);
  public:
    VectorND() { }                          // default constructor
    explicit VectorND (T v0);               // init elements to v0
    explicit VectorND (T v[n]);             // init elements by array
    T& operator[](int i);                   // index notation, i >= 1
    const T& operator[](int i) const;       // read-only access
    T inner(const VectorND<T,n>& v) const;  // inner product
    VectorND<T,n> operator +(const VectorND<T,n> v) const;
    void display() const;
/* other members */
  private:
    T vec[n];       // internal array of type T
};

//// function prototypes
template <typename T, int n> 
VectorND<T,n> operator*(int m, const VectorND<T,n>& v);

template <typename T, int n> 
VectorND<T,n> operator*(const VectorND<T,n>& v, int m);
#endif
