///////    balance.C    ///////
#include <stack>        // use standard stack
#include "balance.h"
using std::stack; 

bool isOpen(char c)
{  return (c=='(' || c=='[' || c=='{' || c=='<'); }

char isClose(char c);

bool balance(istream& in)
{  stack<char> stk;                  // stack
   char c;
   while ( in >> c )
   {  if ( isOpen(c) ) stk.push(c);  // push open bracket
      else if ( c=isClose(c) )         // close bracket
      {  if ( stk.empty() )          // (1)
            return false;            // imbalance
         else if ( c==stk.top() )    // if matching
            stk.pop();               // pop matching open bracket
         else 
            return false;            // bracket mismatch
      }
   }
   return stk.empty();               // balanced if empty
}

char isClose(char c)
{  switch(c)
   {   case '>': return '<';
       case '}': return '{';
       case ']': return '[';
       case ')': return '(';
   }
   return '\0';
}
