///////    FormData.C    ///////
#include <stdlib.h>
#include "FormData.h"

FormData::FormData()
{   content =empty = method = "";
    error = inputContent();
    if ( error == NO_E ) unpack();
}

FormData::ERROR FormData::inputContent()
{   char *s = getenv("REQUEST_METHOD");
    if (s == NULL) return METHOD_E;    // no method
    method = s;
    if (method == "POST")
    {  s =getenv("CONTENT_LENGTH");
       if (s == NULL || *s == '\0')  // no length
          return LENGTH_E;  
       char* t = s ;
       int len=strtol(s, &t, 10);
       if ( *t != '\0' )             // invalid length
          return LENGTH_E;
       char c;
       while ( len-- > 0  && cin.get(c) ) 
            content += c;
       if (len > 0) return CONTENT_E;  // missing content
          
    }
    else if (method == "GET")
    {  s = getenv("QUERY_STRING");
       if (s == NULL || *s == '\0')
          return CONTENT_E;
       content = s;
    }
    else  return METHOD_E;             // unknown method
    return NO_E;
}

void FormData::unpack()
{   Tokenizer tk(content, "&");
    string s1;
    while ( tk.moreToken() )
    {   Tokenizer nv(s1=tk.nextToken(), "=");
        int count=nv.tokenCount();
        if ( count == 2 )  // assume one or two tokens
        {   string nm = nv.nextToken();
            string value = nv.nextToken();
            urlDecode(value);
            data[nm]=value;
            name.push_back(nm);
        }
        else if ( count == 1 )
            data[nv.nextToken()]="";
    }
}

void FormData::urlDecode(string& s)
{   int x1, x2, len = s.size(), pos=0;
    char c, space = ' ';
    for (int i=0; i < len; i++)
    {  c = s[i];
        if ( c == '+' )  s[pos++] = space;
        else if ( c == '%' )
        {  char x[3] = {s[++i], s[++i], '\0'};
           char* t = x;
           int hex=strtol(x, &t, 16);
           if (*t != '\0')  // hex seq invalid
           {   s[pos++]=c;
               s[pos++]=x[0];
               s[pos++]=x[1];
           }
           else
               s[pos++] = static_cast<char>(hex);
        }
        else if ( pos == i ) pos++;
        else s[pos++]=c;
    }
    s.erase(pos,len-pos);  // shorten string
}

const string& FormData::operator [](string key)
{   if ( error == NO_E && hasValue(key) )
         return data[key];
    else
         return empty;
}

void FormData::displayError(ostream& out) const
{   switch(error)
    {   case METHOD_E: 
           out << "Invalid REQUEST_METHOD." << endl;
           break;
        case LENGTH_E: 
           out << "Invalid CONTENT_LENGTH." << endl;
           break;
        case CONTENT_E: 
           out << "Missing content." << endl;
           break;
    }
}
