#ifndef __FormData_H_SEEN__
#define __FormData_H_SEEN__
///////    FormData.h    ///////
#include <iostream>
#include <string>
#include "../ex06/token/Tokenizer.h"
#include <vector>
#include <map>
using std::string; using std::map; 
using std::ostream; using std::cerr; 

class FormData
{ public:
     FormData();
     const string& operator [](string key);
     const string& key(int i) const
     {  return (i < name.size()) ? name[i]
                                 : empty;
     }
     int keyCount() const  {  return name.size(); } 
     void enter(string key, string value)
     {  data[key]=value;  }
     const string& getMethod() const
     {  if ( error==NO_E ) return method;  }
     const string& getContent() const
     {  if ( error==NO_E ) return content;  }
     bool hasValue(string key) const
     {  return (data.find(key) != data.end()); }
     bool operator !()
     {  return error != NO_E;  }
     void displayError(ostream& out=cerr) const;
     enum ERROR {NO_E, METHOD_E, LENGTH_E, CONTENT_E};
  private:
     ERROR inputContent();
     void unpack();
     static void urlDecode(string& v);  // v decoded
     map<string, string> data;
     vector<string> name;
     string content;
     string method;
     string empty;
     ERROR error;
};
#endif
