///////    suggest.C    ///////
#include <iostream>
#include <fstream>
#include <strstream>
#include <string>
#include <time.h>
#include "Html.h"
#include "FormData.h"
using std::ostream; using std::endl;
using std::ostrstream;

void enterLog(ofstream& out, FormData& form, time_t tod)
{   out << "Subject: " << form["subject"] << endl
        << "From: " << form["email"] 
        << "  <" << form["name"] << ">" << endl
        << "Date: " << ctime(&tod) << endl;
    out << endl
        << form["comment"] << endl;
    out.close();
}

void errorReply(Html& page)
{   page.leader("Form Incomplete");
    page.send("<h3>Please Complete All Information</h3><p>"
               "There are missing entries on your form.<p> "
                "Please go back, complete the form, "
                "and submit it again.<p> Thanks.<p>");
    page.trailer();
}

void sorryReply(Html& page)
{   page.leader("Sorry");
    page.send("<h3>Unable to process you message</h3><p>"
          "Sorry, we ran into some difficulty "
          "submitting your message.  Please "
          "enter your message again at a later time.<p>");
    page.trailer();
}

void okReply(Html& page, char* file)
{   page.leader("Thank You");
    page.send("<h3>Thank You</h3><p>"
         "Your message has been logged.<p>"
         "We confirm receipt of the following:<p><pre>\n\n");
    page.sendFile(file);
    page.send("\n</pre>");
    page.trailer();
}

int main()
{   const char *LOGDIR = "feedback_log/";   // dir location
    const int SIZE = 256;
    char logfile[SIZE];
    ostrstream mystr(logfile, SIZE);  // output strstream obj
    time_t tod;
    time(&tod);
    mystr << LOGDIR << tod << ".txt" << '\0';
    Html page;
    FormData form;
    if ( ! form || ! form.hasValue("subject")
                || ! form.hasValue("email")
                || ! form.hasValue("comment")
       )
    {   errorReply(page);
        return 1;
    }
    ofstream out(logfile); 
    if ( ! out )
    {  sorryReply(page);
       return 1;
    }
    enterLog(out, form, tod);
    okReply(page, logfile);
    return 0;
}

