///////    CalcFace.C    ///////
#include  <iostream>
#include  <strstream>
#include  "CalcFace.h"
using std::ios; using std::cout;

CalcFace::CalcFace(const int d, const char* k) 
:  prec(d), keys(string(k)),
   nbuf (new char[d+2])   // includes . and '\0'
{ }

inline int CalcFace::nump(char c)
       {  return( c == '.' || isdigit(c) );  }

void CalcFace::extractNumber(double& number) const
{   if ( nbuf[0] == '\0' )
         number = 0.0;
    else
    {    istrstream tmp(nbuf, prec + 1);
         tmp >> number;
    }
}

int CalcFace::errInput(char& op)
{   int c;
    while ( (c = inchar()) != 'q' && c != 'Q' )
    {   if ( strchr("AaCc", c) )
        {   op = c;
            return OPONLY;
        }
    }
    return OFF;
}

int CalcFace::input(char& op, double& number, int err)
{      if ( err ) return errInput(op);

       int c, current_position = 0, num=0;
       while ( (c = inchar()) != 'q' && c != 'Q' )
       {   if ( keys.find(c) != string::npos )  // if c an operator
           {  op = c; 
              if ( num ) 
              {   nbuf[current_position] = '\0';
                  extractNumber(number);
                  return OK;
              }
              else return OPONLY;
           }
           if ( nump(c) && current_position < prec )
           {  num = 1;
              buildNumber(c, current_position);
           }
       }  // end of while
       return OFF;  // end of input
}

void CalcFace::buildNumber(char c, int& i)
{    static int point_seen = 0;
     if ( i == 0 ) point_seen = 0;        // reset
     if ( i == 0 && c == '0') return;     // ignore leading zeros
     if ( c == '.' )                      // at most one decimal point
     {    if ( point_seen ) return;
          else point_seen = 1;
     }
     nbuf[i++] = c;                       // current_position++
}

void CalcFace::showNumber(double number) const
{   cout.precision(prec);
    cout.setf(ios::fixed);
    cout << "Calc:  " << number << endl;
}
