#ifndef CalcFace__SEEN
#define CalcFace__SEEN
///////    CalcFace.h    ///////
#include <iostream>
#include <string>
using std::string; using std::cin;
using std::endl;  

// function input: returns op in c and input number if any
//     return value == OK means both op and number are obtained
//     return value == OPONLY means only op is obtained
//     return value == OFF means no more input 

// prec is number of digits displayed

class CalcFace
{   public:
        CalcFace( const int digs,    // calculator precision
                  const char* k      // operation keys recognized
                );
        virtual int input(char& c, double& number, int err);
        virtual void showNumber(double number) const;
        virtual void showError() const
        {   cerr << "Error" << endl;   }
        virtual void showOp(char op) const { }
        virtual int errInput(char& op);
        enum {OK=0, OPONLY=1, OFF=2, PREC=6};
        ~CalcFace() { delete nbuf;  }
    protected:
        virtual int inchar() const
        {  return cin.get(); }
        virtual void extractNumber(double&) const;
        virtual void buildNumber(char c, int& i);
        static int nump(char c);
        char*         nbuf;     // buffer[prec+2] for input number
        const string  keys;     // keys
        const int     prec;     // precision
};
#endif

