///////    CalcWindow.C    ///////
#include "CalcWindow.h"

CalcWindow::CalcWindow(int d, CursesWindow* parent)
: CursesWindow(parent, 5, d+14,  5, 16, 'r')
{    int width = d+4;
     x0 = 5; x1 = x0+width-1;   // begin and end of LCD
     Box('#','#');
     init();
}

CalcWindow::~CalcWindow()
{  cleanUp(); }


void CalcWindow::clearLcd()
{   Standout();
    for (int i=x0; i <= x1; i++)
          Mvaddch(2, i, ' ');
    Standend();
    Refresh();
}

void CalcWindow::lcd(int x, char* str)
{   Standout();           // standout mode begin
    Mvaddstr(2, x, str);
    Standend();           // standout mode end
    Refresh();
}

void CalcWindow::showStr(char* b)
{   lcd(x1-strlen(b)+1, b);
}

void CalcWindow::showOp(char op)
{   Mvaddch(3, x1 + 2, op);    
    Refresh();
}

void CalcWindow::init()
{     fflush(stdin);
      fflush(stdout);
      noecho();      // do not echo input characters
      cbreak();      // set to cbreak mode
}

void CalcWindow::cleanUp()
{   Clear();
    Refresh();
    fflush(stdin);
    fflush(stdout);
}
