///////     NList.h    ///////
//  nested list objects
#ifndef Nlist_SEEN__
#define Nlist_SEEN__

class NList;

class NItem
{ friend class NList;
  private:
    enum CL {CHAR, LIST};
    union
    {   char    ch;
        NList&  lis;
    };
    CL l_c;  // CHAR or LIST indicator
    NItem* next;
    NItem(char c = '\0', NItem* ptr = NULL)
    :  l_c(CHAR), ch(c), next(ptr) { }    // constructor
    NItem(NList& nl, NItem* ptr = NULL)
    :  l_c(LIST), lis(nl), next(ptr) { }  // constructor
};


class NList
{ public:
    NList() : head(NULL) { }           // empty list constructor 
    NList(char c)                      // list with first cell
    : head (new NItem(c,NULL)) { }
    bool putOn(char c);                // put on a char
    bool putOn(NList& c);              // put on a nested list
    bool insert(NList& nl, NItem* e);
    bool insert(char c, NItem* e);
    int  depth();                      // depth of nesting
    NItem* last();
    bool append(char c);
    bool append(NList& nl);
    void display(NItem* p);            // display from p to end
    void display() { display(head); }  // display whole list
    /*   ...  */
  private:
    NItem* head;                       // first cell of list
    void free();                       // free all cells
};
#endif
